// messages.dart

import 'dart:convert' show json;
import 'package:http/http.dart' as http;
import './constants.dart';
import './utils.dart';

class Messages {
  final String _user;
  final String _pwd;

  const Messages(this._user, this._pwd);

//Send SMS
  Future<Map> sendsms(data) async {
    http.Client client = http.Client();

    String url = '${SMSALERT_API_BASE_URL}/push.json';
    
    try {
      http.Response response = await client.post(url, headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'Authorization': 'Basic ' + toAuthCredentials(_user, _pwd)
      }, body: {
        'sender': data['from'],
        'mobileno': data['to'],
        'text': data['body'],
        'route':data['route'],
      });
      return (json.decode(response.body));
    } catch (e) {
      return ({'Runtime Error': e});
    } finally {
      client.close();
    }
  }

//Schedule SMS
Future<Map> schedulesms(data) async {
    http.Client client = http.Client();

    String url = '${SMSALERT_API_BASE_URL}/push.json';
    
    try {
      http.Response response = await client.post(url, headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'Authorization': 'Basic ' + toAuthCredentials(_user, _pwd)
      }, body: {
        'sender': data['from'],
        'mobileno': data['to'],
        'text': data['body'],
        'schedule':data['schedule']
      });
      return (json.decode(response.body));
    } catch (e) {
      return ({'Runtime Error': e});
    } finally {
      client.close();
    }
  }
//Credit status
  Future<Map> creditstatus(_user, _pwd) async {
    http.Client client = http.Client();

    String url = '${SMSALERT_API_BASE_URL}/creditstatus.json';
    print(url);
    print('Basic ' + toAuthCredentials(_user, _pwd));

    try {
      http.Response response = await client.post(url, headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'Authorization': 'Basic ' + toAuthCredentials(_user, _pwd)
      });

      return (json.decode(response.body));
    } catch (e) {
      return ({'Runtime Error': e});
    } finally {
      client.close();
    }
  }

//SenderID list
  Future<Map> senderlist(_user, _pwd) async {
    http.Client client = http.Client();

    String url = '${SMSALERT_API_BASE_URL}/senderlist.json';
    print(url);
    print('Basic ' + toAuthCredentials(_user, _pwd));

    try {
      http.Response response = await client.post(url, headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'Authorization': 'Basic ' + toAuthCredentials(_user, _pwd)
      });

      return (json.decode(response.body));
    } catch (e) {
      return ({'Runtime Error': e});
    } finally {
      client.close();
    }
  }

//Generate otp
  Future<Map> sendotp(data) async {
    http.Client client = http.Client();

    String url = '${SMSALERT_API_BASE_URL}/mverify.json';
    print(url);
    print('Basic ' + toAuthCredentials(_user, _pwd));

    try {
      http.Response response = await client.post(url, headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'Authorization': 'Basic ' + toAuthCredentials(_user, _pwd)
      }, body: {
        'sender': data['from'],
        'mobileno': data['to'],
        'template': data['template']
      });

      return (json.decode(response.body));
    } catch (e) {
      return ({'Runtime Error': e});
    } finally {
      client.close();
    }
  }

//Verify otp
  Future<Map> verifyotp(data) async {
    http.Client client = http.Client();

    String url = '${SMSALERT_API_BASE_URL}/mverify.json';
    print(url);
    print('Basic ' + toAuthCredentials(_user, _pwd));

    try {
      http.Response response = await client.post(url, headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'Authorization': 'Basic ' + toAuthCredentials(_user, _pwd)
      }, body: {
        'mobileno': data['to'],
        'code': data['code']
      });

      return (json.decode(response.body));
    } catch (e) {
      return ({'Runtime Error': e});
    } finally {
      client.close();
    }
  }

//used to send sms report
  Future<Map> smsreport(data) async {
    http.Client client = http.Client();

    String url = '${SMSALERT_API_BASE_URL}/smscampaignlog.json';
    print(url);
    print('Basic ' + toAuthCredentials(_user, _pwd));

    try {
      http.Response response = await client.post(url, headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'Authorization': 'Basic ' + toAuthCredentials(_user, _pwd)
      }, body: {
        'limit': data['limit'],
        'page': data['page'], 
        'schedule': data['schedule'] 
      });

      return (json.decode(response.body));
    } catch (e) {
      return ({'Runtime Error': e});
    } finally {
      client.close();
    }
  }


  Future<Map> pullreport(data) async {
    http.Client client = http.Client();

    String url = '${SMSALERT_API_BASE_URL}/pull.json';
    print(url);
    print('Basic ' + toAuthCredentials(_user, _pwd));

    try {
      http.Response response = await client.post(url, headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'Authorization': 'Basic ' + toAuthCredentials(_user, _pwd)
      }, body: {
        'batchid': data['batchid'] 
        });

      return (json.decode(response.body));
    } catch (e) {
      return ({'Runtime Error': e});
    } finally {
      client.close();
    }
  }

  Future<Map> getcountries(_user, _pwd) async {
    http.Client client = http.Client();

    String url = '${SMSALERT_API_BASE_URL}/countrylist.json';
    print(url);
    print('Basic ' + toAuthCredentials(_user, _pwd));

    try {
      http.Response response = await client.post(url, headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'Authorization': 'Basic ' + toAuthCredentials(_user, _pwd)
      });

      return (json.decode(response.body));
    } catch (e) {
      return ({'Runtime Error': e});
    } finally {
      client.close();
    }
  }


  Future<Map> sendgroupsms(data) async {
    http.Client client = http.Client();

    String url = '${SMSALERT_API_BASE_URL}/grouppush.json';
    print(url);
    print('Basic ' + toAuthCredentials(_user, _pwd));

    try {
      http.Response response = await client.post(url, headers: {
        'Content-Type': 'application/x-www-form-urlencoded',
        'Authorization': 'Basic ' + toAuthCredentials(_user, _pwd)
      }, body: {
        'id': data['id'],
        'sender': data['sender'],
        'text': data['text']
        });

      return (json.decode(response.body));
    } catch (e) {
      return ({'Runtime Error': e});
    } finally {
      client.close();
    }
  }
}
